Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs	(revision 15771)
@@ -1,12 +1,7 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
+﻿using System;
+using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-  using Attributes;
-
-  using HeuristicLab.Common;
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-  using Interpreter;
-  using Stack;
+namespace HeuristicLab.Problems.ProgramSynthesis {
 
   /// <summary>
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs	(revision 15771)
@@ -1,10 +1,7 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using System.Linq;
+﻿using System;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-  using Attributes;
-  using Interpreter;
-  using Persistence.Default.CompositeSerializers.Storable;
-  using Stack;
+namespace HeuristicLab.Problems.ProgramSynthesis {
 
   /// <summary>
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 15771)
@@ -1,17 +1,12 @@
-﻿// For explicit code manipulation and execution. May also be used as a general list data types.
-// This types must always be present, as the top level interpreter will push any code to be executed on the
-// CODE stack prior to execution. However, one may turn off all CODE instructions if code manipulation is not needed.
-
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using System.Collections.Generic;
-  using System.Linq;
-  using Attributes;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
-
-  using Interpreter;
-  using Stack;
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
+  // For explicit code manipulation and execution. May also be used as a general list data types.
+  // This types must always be present, as the top level interpreter will push any code to be executed on the
+  // CODE stack prior to execution. However, one may turn off all CODE instructions if code manipulation is not needed.
 
   /// <summary>
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs	(revision 15771)
@@ -1,12 +1,7 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using System.Collections.Generic;
-
-  using Attributes;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-  using Interpreter;
-  using Stack;
+﻿using System;
+using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
 
   /// <summary>
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs	(revision 15771)
@@ -1,9 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using Attributes;
-  using Interpreter;
-  using Persistence.Default.CompositeSerializers.Storable;
-  using Stack;
+﻿using System;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// An iteration instruction that performs a loop (the body of which is taken from the CODE stack) the number of times
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs	(revision 15771)
@@ -1,8 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using Attributes;
-  using Interpreter;
-  using Persistence.Default.CompositeSerializers.Storable;
-  using Stack;
+﻿using System;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
 
   /// <summary>
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs	(revision 15771)
@@ -1,8 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using Attributes;
-  using Interpreter;
-  using Persistence.Default.CompositeSerializers.Storable;
-  using Stack;
+﻿using System;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
 
   /// <summary>
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs	(revision 15771)
@@ -1,9 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
 
   /// <summary>
@@ -88,5 +85,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.DUP", "Duplicates the top item on the EXEC stack." , requiredBlockCount: 1)]
+  [PushExpression(StackTypes.Exec, "EXEC.DUP", "Duplicates the top item on the EXEC stack.", requiredBlockCount: 1)]
   public class ExecDuplicateExpression : DuplicateExpression<Expression> {
     public ExecDuplicateExpression() { }
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpression.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpression.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpression.cs	(revision 15771)
@@ -1,10 +1,5 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-
-  using Stack;
-
+﻿using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Tells whether that stack is empty.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 15771)
@@ -1,12 +1,7 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
-  using System.Linq;
-
-  using Attributes;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-  using Interpreter;
-  using Stack;
+﻿using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
 
   /// <summary>
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 15771)
@@ -1,10 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
-  using Interpreter;
+﻿using System;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
 
   /// <summary>
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 15771)
@@ -1,10 +1,8 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
+﻿using System;
 
-  using HeuristicLab.Common;
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
+using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-  using Interpreter;
+namespace HeuristicLab.Problems.ProgramSynthesis {
 
   [Serializable]
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 15771)
@@ -1,13 +1,7 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using System.Collections.Generic;
-  using System.Linq;
-
-  using Attributes;
-  using Data.Pool;
-
-  using HeuristicLab.Problems.ProgramSynthesis.Base.Extensions;
-
-  using Stack;
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
 
   public static class ExpressionTable {
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs	(revision 15771)
@@ -1,13 +1,9 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using System.Globalization;
-
-  using Common;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+﻿using System;
+using System.Globalization;
+
+using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Pushes the sum of the top two items.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs	(revision 15771)
@@ -1,11 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-
-  using Interpreter;
-  using Stack;
-
+﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Empties the given stack.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/InExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/InExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/InExpressions.cs	(revision 15771)
@@ -1,8 +1,5 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+﻿using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// InExpression has a state, but this state is static at compile time and therefore InExpression can be seen as stateless at runtime
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs	(revision 15771)
@@ -1,11 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
-  using Interpreter;
-
+﻿using System;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Pushes the sum of the top two items.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs	(revision 15771)
@@ -1,10 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Linq;
+﻿using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-  using Interpreter;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   [StorableClass]
   public class NameDefineXExecExpression : StatefulExpression<string> {
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs	(revision 15771)
@@ -1,11 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-
-  using Interpreter;
-  using Stack;
-
+﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
   [StorableClass]
   public abstract class PopExpression<T> : StatelessExpression {
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs	(revision 15771)
@@ -1,12 +1,7 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
-  using System.Globalization;
-  using Attributes;
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Constants;
-
-  using Interpreter;
-  using Stack;
-
+﻿using System.Collections.Generic;
+using System.Globalization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
   [StorableClass]
   [PushExpression(StackTypes.Print, "PRINT.NEWLINE", "Pushes an empty string onto the PRINT STACK.")]
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs	(revision 15771)
@@ -1,14 +1,8 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using System.Collections.Generic;
-  using System.Linq;
-  using Attributes;
-  using Constants;
-  using Data.Pool;
-  using Extensions;
-  using Interpreter;
-  using Persistence.Default.CompositeSerializers.Storable;
-  using Stack;
-
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
   [Serializable]
   [StorableClass]
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs	(revision 15771)
@@ -2,17 +2,11 @@
 using System.Collections.Generic;
 using System.Linq;
-
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Diagnostics;
-  using System.Diagnostics.CodeAnalysis;
-
-  using Constants;
-  using Data.Pool;
-  using Extensions;
-
-  using HeuristicLab.Common;
-
-  using Interpreter;
-  using Persistence.Default.CompositeSerializers.Storable;
+using System.Diagnostics;
+using System.Diagnostics.CodeAnalysis;
+
+using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
 
   [Serializable]
@@ -133,8 +127,6 @@
     [NonSerialized]
     private string stringRepresentation;
-    public override string StringRepresentation
-    {
-      get
-      {
+    public override string StringRepresentation {
+      get {
         return stringRepresentation ?? (stringRepresentation = BuildStringRepresentation());
       }
@@ -144,8 +136,6 @@
     [NonSerialized]
     private int? depth;
-    public int Depth
-    {
-      get
-      {
+    public int Depth {
+      get {
         if (depth == null) depth = CalcDepth();
         return depth.Value;
@@ -155,8 +145,6 @@
     [NonSerialized]
     private int[] treeIndex;
-    private int[] TreeIndex
-    {
-      get
-      {
+    private int[] TreeIndex {
+      get {
         return treeIndex ?? (treeIndex = BuildTreeIndex());
       }
@@ -212,8 +200,6 @@
     /// </summary>
     /// <returns></returns>
-    public int TotalCount
-    {
-      get
-      {
+    public int TotalCount {
+      get {
         if (totalCount == null) {
           totalCount = IsEmpty
@@ -233,8 +219,6 @@
     /// </summary>
     /// <returns></returns>
-    public int TotalInstructionCount
-    {
-      get
-      {
+    public int TotalInstructionCount {
+      get {
         if (totalInstructionCount == null) {
           totalInstructionCount = 0;
@@ -259,8 +243,6 @@
     /// </summary>
     /// <returns></returns>
-    public int Branches
-    {
-      get
-      {
+    public int Branches {
+      get {
         if (branches == null) CountBranches();
         return branches.Value;
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs	(revision 15771)
@@ -1,12 +1,7 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
-  using System.Linq;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Generators.CodeGenerator;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+﻿using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
 
   /// <summary>
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs	(revision 15771)
@@ -1,11 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-
-  using Interpreter;
-  using Stack;
-
+﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
   [StorableClass]
   public abstract class RotateExpression<T> : StatelessExpression {
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs	(revision 15771)
@@ -1,13 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
-
-  using Attributes;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
-
-  using Interpreter;
-  using Stack;
-
+﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
   [StorableClass]
   public abstract class ShoveExpression<T> : StatelessExpression {
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs	(revision 15771)
@@ -1,11 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-
-  using Interpreter;
-  using Stack;
-
+﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   ///     Pushes the stack depth onto the INTEGER stack (thereby increasing it!).
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs	(revision 15771)
@@ -1,9 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
+﻿using System;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-  using HeuristicLab.Common;
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   [Serializable]
   [StorableClass]
@@ -34,8 +31,6 @@
     }
 
-    public override string StringRepresentation
-    {
-      get
-      {
+    public override string StringRepresentation {
+      get {
         return stringRepresentation ?? (stringRepresentation = GetStringRepresentation());
       }
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatelessExpression.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatelessExpression.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatelessExpression.cs	(revision 15771)
@@ -1,3 +1,3 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+﻿namespace HeuristicLab.Problems.ProgramSynthesis {
   using System;
 
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs	(revision 15771)
@@ -1,15 +1,8 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using System.Globalization;
-  using System.Linq;
-
-  using Attributes;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
-
-  using Interpreter;
-  using Stack;
-
+﻿using System;
+using System.Globalization;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Stringifies and pushes the top INTEGER.,
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs	(revision 15771)
@@ -1,11 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-
-  using Interpreter;
-  using Stack;
-
+﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   ///     Swaps the top two values.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorButLastExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorButLastExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorButLastExpressions.cs	(revision 15771)
@@ -1,11 +1,7 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
-  using System.Linq;
+﻿using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Takes the rest of the top item on the type stack.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConcatExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConcatExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConcatExpressions.cs	(revision 15771)
@@ -1,10 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
+﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Concatinates two vectors on the type stack.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConjExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConjExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorConjExpressions.cs	(revision 15771)
@@ -1,10 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
+﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Conj's an item onto the type stack.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorContainsExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorContainsExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorContainsExpressions.cs	(revision 15771)
@@ -1,12 +1,7 @@
 ﻿using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Linq;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Tells whether the top lit-type item is in the top type vector.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorEmptyExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorEmptyExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorEmptyExpressions.cs	(revision 15771)
@@ -1,10 +1,6 @@
 ﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Pushes a boolean of whether the top vector is empty.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorFirstExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorFirstExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorFirstExpressions.cs	(revision 15771)
@@ -1,10 +1,6 @@
 ﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Gets the first item from the type stack
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIndexOfExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIndexOfExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIndexOfExpressions.cs	(revision 15771)
@@ -1,10 +1,6 @@
 ﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Finds the index of the top lit-type item in the top type vector.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs	(revision 15771)
@@ -1,13 +1,8 @@
 ﻿using System.Collections.Generic;
+using System;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using System.Linq;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Iterates in reverse order (due to performance reasons) over the type vector using the code on the exec stack.If the vector isn't empty, expands to:
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLastExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLastExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLastExpressions.cs	(revision 15771)
@@ -1,10 +1,6 @@
 ﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Gets the last item from the type stack
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLengthExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLengthExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorLengthExpressions.cs	(revision 15771)
@@ -1,10 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
+﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Takes the length of the top item on the type stack
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorNthExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorNthExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorNthExpressions.cs	(revision 15771)
@@ -1,12 +1,6 @@
 ﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Gets the nth item from the type stack
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorOccurrenceOfExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorOccurrenceOfExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorOccurrenceOfExpressions.cs	(revision 15771)
@@ -1,10 +1,6 @@
 ﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Counts the occurrences of the top lit-type item in the top type vector.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorPushAllExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorPushAllExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorPushAllExpressions.cs	(revision 15771)
@@ -1,11 +1,7 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
-  using System.Linq;
+﻿using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Pushes every item from the first vector onto the appropriate stack in reversed order.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRemoveExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRemoveExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRemoveExpressions.cs	(revision 15771)
@@ -1,12 +1,7 @@
 ﻿using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Linq;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Removes all occurrences of the first lit-type item in the top type vector.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReplaceExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReplaceExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReplaceExpressions.cs	(revision 15771)
@@ -1,10 +1,6 @@
 ﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Replaces all occurrences of the second lit-type item with the first lit-type item in the top type vector.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReplaceFirstExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReplaceFirstExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReplaceFirstExpressions.cs	(revision 15771)
@@ -1,10 +1,6 @@
 ﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Replace first occurrence of the second lit-type item with the first lit-type item in the top type vector.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRestExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRestExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRestExpressions.cs	(revision 15771)
@@ -1,12 +1,8 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using System.Collections.Generic;
-  using System.Linq;
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Takes the rest of the top item on the type stack.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReverseExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReverseExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReverseExpressions.cs	(revision 15771)
@@ -1,12 +1,7 @@
 ﻿using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Linq;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Takes the reverse of the top item on the type stack.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSetExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSetExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSetExpressions.cs	(revision 15771)
@@ -1,11 +1,6 @@
 ﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Replaces, in the top type vector, item at index(from integer stack) with the first lit-type item.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSubExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSubExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSubExpressions.cs	(revision 15771)
@@ -1,13 +1,8 @@
 ﻿using System.Collections.Generic;
+using System;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using System.Linq;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Takes the subvec of the top item on the type stack.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorTakeExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorTakeExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorTakeExpressions.cs	(revision 15771)
@@ -1,14 +1,8 @@
 ﻿using System.Collections.Generic;
+using System;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using System.Linq;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Takes the first N items from the type stack, where N is from the integer stack
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs	(revision 15771)
@@ -1,13 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System;
-  using System.Collections.Generic;
-  using Attributes;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
-
-  using Interpreter;
-  using Stack;
-
+﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Pushes a copy of an indexed item "deep" in the stack onto the top of the stack, without removing the deep item.
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs	(revision 15771)
@@ -1,11 +1,6 @@
-﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using System.Collections.Generic;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+﻿using System.Collections.Generic;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
   /// <summary>
   /// Removes an indexed item from "deep" in the stack and pushes it on top of the stack.
